//
// Created by philipp on 12.02.18.
//

#ifndef CAR_PLATOONCONTROLLER_H
#define CAR_PLATOONCONTROLLER_H

#include <functional>

#include "PlatoonProtocolLib/VehicleFacade.h"
#include "PlatoonProtocolLib/Protocol.h"
#include "PC2CarLib/CommandReceiver.h"
#include "EgoMotion.h"
#include "PlatoonState.h"
#include <atomic>

namespace car
{

class PlatoonController
{
public:
    using Callback = std::function<void()>;
    
    PlatoonController(platoonProtocol::VehicleFacade& c2c,
                      pc2car::CommandReceiver::Ptr pc,
                      EgoMotion& egoMotion);
      
    void run();
    
    Callback cruiseControllerNotify;
     
    // TODO check these values !
    // TODO make values ATOMIC !
    // these values need to be stored and atomic, since they will be pulled from other modules
    PlatoonState curState = PlatoonState::CACC_FV;
    float        desSpeed = 0.0;
    platoonProtocol::PlatoonConfig platoonConfig;

private:

    platoonProtocol::VehicleFacade& c2c;
    bool c2cAlive = false;
    
    pc2car::CommandReceiver::Ptr pc;
    
    EgoMotion& egoMotion;
    
    // METHODS
    void run_ACC();
    void run_CACC_FV();
    void run_CACC_LV();
    
};

}

#endif //CAR_PLATOONCONTROLLER_H
